@REM
@REM
@REM
@set scheme_drive=e
@set scheme_root=e:\scheme-7.4t
@set scheme_lib=%scheme_root%\lib
@set  scheme_microcode=%scheme_root%\ntucode
@set            scheme=%scheme_root%\bin\scheme -library %scheme_lib%
@set        big_scheme=%scheme% -heap 2000
@set    scheme_compile=%big_scheme% -compiler -no-init-file -load %scheme_root%/etc/compile.scm
@set scheme_build_band=%big_scheme% -no-init-file -load %scheme_root%/etc/build.scm
@set scheme_build_delta=%big_scheme% -no-init-file -load %scheme_root%/etc/delta.scm
@set save_band=pkzip -i %scheme_lib%\safe.zip 

:dispatch
@%scheme_drive%:
@cd %scheme_root%
@REM if _%1==_everything goto do_everything
@if _%1==_everything goto do_runtime
@if _%1==_microcode goto do_microcode
@if _%1==_dibutils goto do_dibutils
@if _%1==_bin goto do_bin
@if _%1==_runtime goto do_runtime
@if _%1==_runtime_band goto do_runtime_band
@if _%1==_eddel goto do_eddel
@if _%1==_edwin goto do_edwin
@if _%1==_compdel goto do_compdel
@if _%1==_compiler goto do_compiler
@if _%1==_all goto do_all_band
@if _%1==_6001 goto do_6001
@if _%1==_6001del goto do_6001del
@if _%1==_checked goto do_checked
@if _%1==_6001_band goto do_6001_band

@echo .
@echo Usage: rebuild [microcode] [bin] [runtime] [eddel] [edwin] [compdel] [compiler] [all]
@echo .
@echo . microcode - scheme.exe
@echo . bin      - install .exe files
@echo . runtime  - compile runtime, make runtime.com
@echo . eddel    - compile edwin and make eddel.com
@echo . edwin    - create edwin.com band from runtime.com and eddel.com
@echo . compdel  - compile compiler and create compdel.com
@echo . compiler - create compiler.com band from runtime.com and compdel.com
@echo . all      - create all.com band from runtime.com compdel.com and eddel.com
@echo . 6001del  - compile 6001 and create 6001del.com
@echo . 6001     - create 6001.com band from runtime.com, eddel.com and 6001del.com
@echo . everything - do all of the above steps in order
@echo .
@goto end

:next
@shift
@if _%1==_ goto end
@goto dispatch

:do_everything
:do_microcode
@%scheme_drive%:
cd %scheme_microcode%
@call ntutl\config
@if _%Mstools%==_ call setenv
@nmake
@if errorlevel 1 goto abort
cd %scheme_root%
@if _%1==_microcode goto next

:do_dibutils
@%scheme_drive%:
cd %scheme_microcode%
@if _%Mstools%==_ call setenv
@cd ..\win32\dibutils
@nmake
@if errorlevel 1 goto abort
cd %scheme_root%
@if _%1==_dibutils goto next

:do_bin
@cd %scheme_microcode%
copy scheme.exe ..\bin
copy bchschem.exe ..\bin
copy scheme??.dll ..\bin
copy bintopsb.exe ..\bin
copy psbtobin.exe ..\bin
copy %scheme_root%\win32\dibutils\dibutils.dll ..\bin
@if _%1==_bin goto next

:do_runtime
%scheme_compile% -eval (cf.runtime)
@if errorlevel 1 goto abort
%scheme_compile% -eval (cf.win32)
@if errorlevel 1 goto abort
:do_runtime_band
%scheme_drive%:
cd %scheme_root%\runtime
@echo .
@echo Manual steps at Scheme command prompt:
@echo . (cd "../win32")
@echo . (load "make")
@echo . (disk-save "%scheme_lib%\runtime.com")
@echo . (%exit)
@echo .
%big_scheme% -fasl make.com
@if errorlevel 1 goto abort
cd %scheme_root%
@if _%1==_runtime_band goto next
@if _%1==_runtime goto next

:do_eddel
%scheme_compile% -eval (cf.edwin)
@if errorlevel 1 goto abort
%save_band% %scheme_lib%\eddel.com
REM @if errorlevel 1 goto abort
%scheme_build_delta% -eval (pack.eddel)
@if errorlevel 1 goto abort
@if _%1==_eddel goto next

:do_edwin
%scheme_build_band% -eval (edwin.com)
@if _%1==_edwin goto next

:do_compdel
%scheme_compile% -eval (cf.sf)
@if errorlevel 1 goto abort
%scheme_compile% -eval (cf.cref)
@if errorlevel 1 goto abort
%scheme_compile% -eval (cf.compiler)
@if errorlevel 1 goto abort
REM %save_band% %scheme_lib%\compdel.com
@if errorlevel 1 goto abort
%scheme_build_delta% -eval (pack.compdel)
@if errorlevel 1 goto abort
@if _%1==_compdel goto next

:do_compiler
%scheme_build_band% -eval (compiler.com)
@if errorlevel 1 goto abort
@if _%1==_compiler goto next

:do_all_band
%scheme_build_band% -eval (all.com)
@if errorlevel 1 goto abort
@if _%1==_all goto next

:do_6001
:do_6001del
%big_scheme% -band all.com -no-init-file -load %scheme_root%/etc/compile.scm -eval (cf.6001)
@if errorlevel 1 goto abort
%scheme_build_delta% -eval (pack.6001del)
@if errorlevel 1 goto abort
@if _%1==_6001del goto next

@REM :do_checked
@REM copy runtime\runtime.cbf rt-check\runtime.cbf
@REM @if errorlevel 1 goto abort
@REM copy runtime\runtime.bco rt-check\runtime.bco
@REM @if errorlevel 1 goto abort
@REM copy runtime\runtime.bld rt-check\runtime.bld
@REM @if errorlevel 1 goto abort
@REM copy runtime\*.bin rt-check
@REM @if errorlevel 1 goto abort
@REM %scheme_compile% -eval (cf.runtime/checked)
@REM @if errorlevel 1 goto abort
@REM 
@REM copy edwin\edwin.cbf ed-check\edwin.cbf
@REM @if errorlevel 1 goto abort
@REM copy edwin\edwin.bco ed-check\edwin.bco
@REM @if errorlevel 1 goto abort
@REM copy edwin\edwin.bld ed-check\edwin.bld
@REM @if errorlevel 1 goto abort
@REM copy edwin\*.bin ed-check
@REM @if errorlevel 1 goto abort
@REM %scheme_compile% -eval (cf.edwin/checked)
@REM @if errorlevel 1 goto abort
@REM @if _%1==_checked goto next

:do_6001_band
@REM %scheme_drive%:
@REM cd %scheme_root%\rt-check
@REM @echo .
@REM @echo Manual steps at Scheme command prompt:
@REM @echo . (load "../etc/make6001")
@REM @echo .
@REM %big_scheme% -fasl make.com

%scheme_build_band% -eval (6001.com)
@if errorlevel 1 goto abort

cd %scheme_root%
@if _%1==_6001_band goto next
@if _%1==_6001 goto next


%scheme_build_band% -eval (6001.com)
@if errorlevel 1 goto abort
@if _%1==_6001 goto next

@goto end
:abort
@echo .
@echo Error in rebuild %1

:end
@%scheme_drive%:
@cd %scheme_root%
